;Copyright (C) 2009 Eric Bachard

;Website: http://wiki.ooo4kids.org

;This software is OSI Certified Open Source Software.
;OSI Certified is a certification mark of the Open Source Initiative.

;This program is free software; you can redistribute it and/or
;modify it under the terms of the GNU General Public License
;as published by the Free Software Foundation; either version 2
;of the License, or (at your option) any later version.

;This program is distributed in the hope that it will be useful,
;but WITHOUT ANY WARRANTY; without even the implied warranty of
;MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;GNU General Public License for more details.

;You should have received a copy of the GNU General Public License
;along with this program; if not, write to the Free Software
;Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

;01 2009 blank in PORTABLEAPPNAME added to show the Launcher on PortableApps.com menu again
;should be removed with the new suite final!

!define PORTABLEAPPNAME "OOo4KidsPortable"
!define APPNAME "OOo4Kids"
!define NAME "OOo4KidsPortable"
!define FRIENDLYNAME "OOo4Kids Portable"
!define VER "1.1.0.1"
!define WEBSITE "http://wiki.ooo4kids.org"
!define EXECTHIS "OOo4KidsPortable.exe"
!define DEFAULTEXE "soffice.exe"
!define DEFAULTAPPDIR "OOo4Kids"
!define DEFAULTSETTINGSDIR "settings"
!define DEFAULTPARAMETERS ""
!define LAUNCHERLANGUAGE "French" ;one of the NSIS pre-defined languages supported: English, French, Italian, German, Japanese, SimpChinese

;=== Program Details
Name "${PORTABLEAPPNAME}"
OutFile "..\..\${NAME}.exe"
Caption "${PORTABLEAPPNAME} | PortableApps.com"
VIProductVersion "${VER}"
VIAddVersionKey ProductName "${PORTABLEAPPNAME}"
VIAddVersionKey Comments "Allows ${APPNAME} to be run from a removable drive.  For additional details, visit ${WEBSITE}"
VIAddVersionKey CompanyName "EducOO.org"
VIAddVersionKey LegalCopyright "Eric Bachard"
VIAddVersionKey FileDescription "${PORTABLEAPPNAME}"
VIAddVersionKey FileVersion "${VER}"
VIAddVersionKey ProductVersion "${VER}"
VIAddVersionKey InternalName "${PORTABLEAPPNAME}"
VIAddVersionKey LegalTrademarks "OOo4Kids is a Trademark of EducOO.org."
VIAddVersionKey OriginalFilename "${NAME}.exe"
;VIAddVersionKey PrivateBuild ""
;VIAddVersionKey SpecialBuild ""


;=== Runtime Switches
CRCCheck On
WindowIcon Off
SilentInstall Silent
AutoCloseWindow True
RequestExecutionLevel user

; Best Compression
SetCompress Auto
SetCompressor /SOLID lzma
SetCompressorDictSize 32
SetDatablockOptimize On

;=== Include
;(Standard NSIS)
!include FileFunc.nsh
!insertmacro GetParent
!insertmacro GetParameters
!include Registry.nsh

;(Custom)
!include CharToASCII.nsh
!include ReadINIStrWithDefault.nsh
!include SetFileAttributesDirectoryNormal.nsh
!include StrRep.nsh

;=== Program Icon
Icon "..\..\App\AppInfo\appicon.ico"

;=== Languages
LoadLanguageFile "${NSISDIR}\Contrib\Language files\${LAUNCHERLANGUAGE}.nlf"
!include PortableApps.comLauncherLANG_${LAUNCHERLANGUAGE}.nsh

Var PROGRAMDIRECTORY
Var SETTINGSDIRECTORY
Var SETTINGSDIRECTORYWITHOUTSPACES
Var SETTINGSDIRECTORYBOOTSTRAP
Var ADDITIONALPARAMETERS
Var EXECSTRING
Var WAITFORPROGRAM
Var PROGRAMEXECUTABLE
Var INIPATH
Var ISDEFAULTDIRECTORY
Var RUNDATALOCALLY
Var SECONDARYLAUNCH
Var DOCUMENTSDIRECTORY
Var JAVADIRECTORY
Var JAVAVENDOR
Var JAVAVERSION
Var JAVAPATHCONFIG
Var JAVAPATHCONFIGHEX
Var PORTABLEAPPSDIRECTORY
Var PORTABLEAPPSDOCUMENTS
Var PORTABLEAPPSTEMP
Var MISSINGFILEORPATH


Section "Main"
	StrCpy $LANGUAGE ${LANG_${LAUNCHERLANGUAGE}}

	;=== Find the INI file, if there is one
		IfFileExists "$EXEDIR\${NAME}.ini" "" CheckSubINI
			StrCpy $INIPATH "$EXEDIR"
			Goto ReadINI

	CheckSubINI:
		IfFileExists "$EXEDIR\${NAME}\${NAME}.ini" "" NoINI
			StrCpy $INIPATH "$EXEDIR\${NAME}"
			Goto ReadINI

	ReadINI:
		;=== Read the parameters from the INI file
		${ReadINIStrWithDefault} $0 "$INIPATH\${NAME}.ini" "${NAME}" "${APPNAME}Directory" "$EXEDIR\App\${DEFAULTAPPDIR}"
		StrCpy $PROGRAMDIRECTORY "$EXEDIR\$0"
		${ReadINIStrWithDefault} $0 "$INIPATH\${NAME}.ini" "${NAME}" "SettingsDirectory" "$EXEDIR\Data\${DEFAULTSETTINGSDIR}"
		StrCpy $SETTINGSDIRECTORY "$EXEDIR\$0"

		;=== Check that the above required parameters are present
		IfErrors NoINI

		${ReadINIStrWithDefault} $ADDITIONALPARAMETERS "$INIPATH\${NAME}.ini" "${NAME}" "AdditionalParameters" ""
		${ReadINIStrWithDefault} $WAITFORPROGRAM "$INIPATH\${NAME}.ini" "${NAME}" "WaitFor${APPNAME}" "false"
		${ReadINIStrWithDefault} $PROGRAMEXECUTABLE "$INIPATH\${NAME}.ini" "${NAME}" "${APPNAME}Executable" "${DEFAULTEXE}"
		${ReadINIStrWithDefault} $RUNDATALOCALLY "$INIPATH\${NAME}.ini" "${NAME}" "RunDataLocally" "false"
		StrCmp $RUNDATALOCALLY "true" "" CleanUpAnyErrors
			StrCpy $WAITFORPROGRAM "true"
			${registry::Read} "HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders" "Personal" $R0 $R1
			StrCpy $DOCUMENTSDIRECTORY $R0

	CleanUpAnyErrors:
		;=== Any missing unrequired INI entries will be an empty string, ignore associated errors
		ClearErrors

		;=== Correct PROGRAMEXECUTABLE if blank
		StrCmp $PROGRAMEXECUTABLE "" "" EndINI
			StrCpy "$PROGRAMEXECUTABLE" "${DEFAULTEXE}"
			Goto EndINI

	NoINI:
		;=== No INI file, so we'll use the defaults
		StrCpy $ADDITIONALPARAMETERS ""
		StrCpy $WAITFORPROGRAM "false"
		StrCpy $PROGRAMEXECUTABLE "${DEFAULTEXE}"

		IfFileExists "$EXEDIR\App\${DEFAULTAPPDIR}\program\${DEFAULTEXE}" "" NoProgramEXE
			StrCpy $PROGRAMDIRECTORY "$EXEDIR\App\${DEFAULTAPPDIR}"

			;=== Use short path if blanks are detected
  			;===  Check if any spaces exist in $PROGRAMDIRECTORY.
  			;${WordFind} "$PROGRAMDIRECTORY" ' ' "*" $R0
  			;IntCmp $R0 0 NoSpaces
        		;=== use short path if blanks
			;GetFullPathName /SHORT $0 $PROGRAMDIRECTORY
			;StrCpy $PROGRAMDIRECTORY $0  
  			;NoSpaces:

			StrCpy $SETTINGSDIRECTORY "$EXEDIR\Data\${DEFAULTSETTINGSDIR}"
			StrCpy $ISDEFAULTDIRECTORY "true"
			GoTo EndINI

	EndINI:
		IfFileExists "$PROGRAMDIRECTORY\program\$PROGRAMEXECUTABLE" FoundProgramEXE

	NoProgramEXE:
		;=== Program executable not where expected
		StrCpy $MISSINGFILEORPATH $PROGRAMEXECUTABLE
		MessageBox MB_OK|MB_ICONEXCLAMATION `$(LauncherFileNotFound)`
		Abort
		
	FoundProgramEXE:
		;=== Check path length (max 120)
		StrLen $0 $PROGRAMDIRECTORY
		IntCmp $0 120 GoodPath GoodPath ""
		MessageBox MB_OK|MB_ICONEXCLAMATION `$(LauncherPathTooLong)`
		Abort		
	
	GoodPath:
		FindProcDLL::FindProc "soffice.bin"
		Pop $R0
		StrCmp $R0 "1" "" SkipSplashScreen
		StrCmp $RUNDATALOCALLY "true" LocalRunCheckSecondary
		IfFileExists "$SETTINGSDIRECTORY\.lock" "" SkipSplashScreen
		StrCpy $SECONDARYLAUNCH "true"
		Goto SkipSplashScreen

	LocalRunCheckSecondary:
		IfFileExists "$DOCUMENTSDIRECTORY\${NAME}Temp\settings\.lock" "" SkipSplashScreen
			StrCpy $SECONDARYLAUNCH "true"
	
	SkipSplashScreen:
		;=== Run locally if needed (aka Live)
		StrCmp $RUNDATALOCALLY "true" "" SetupDocumentsPath
		StrCmp $SECONDARYLAUNCH "true" SetLocalSettingsDirectory
		RMDir /r "$DOCUMENTSDIRECTORY\${NAME}Temp\"
		CreateDirectory "$DOCUMENTSDIRECTORY\${NAME}Temp\settings"
		CopyFiles /SILENT $SETTINGSDIRECTORY\*.* $DOCUMENTSDIRECTORY\${NAME}Temp\settings
		${SetFileAttributesDirectoryNormal} "$DOCUMENTSDIRECTORY\${NAME}Temp\settings"
	
	SetLocalSettingsDirectory:
		StrCpy $SETTINGSDIRECTORY $DOCUMENTSDIRECTORY\${NAME}Temp\settings
		
	SetupDocumentsPath:
		StrCmp $RUNDATALOCALLY "true" UseDefaultPaths
		StrCmp $SECONDARYLAUNCH "true" CheckForPassedParameters
		StrCmp $ISDEFAULTDIRECTORY "true" "" CheckForPassedParameters
		IfFileExists "$SETTINGSDIRECTORY\user\*.*" DataPathsCreated
			CreateDirectory "$EXEDIR\Data\temp\"
			CreateDirectory "$SETTINGSDIRECTORY\"
			CreateDirectory "$SETTINGSDIRECTORY\user\registry\data\org\openoffice\Office\"
			CopyFiles /SILENT "$EXEDIR\App\DefaultData\settings\user\registry\data\org\openoffice\Office\*.*" "$SETTINGSDIRECTORY\user\registry\data\org\OOo4Kids\Office\"

	DataPathsCreated:
		ReadEnvStr $PORTABLEAPPSDOCUMENTS "PortableApps.comDocuments"
		StrCmp $PORTABLEAPPSDOCUMENTS "" "" SetupDocumentsPathPortableApps

		Goto CheckForPassedParameters

		UseDefaultPaths:
			Delete "$SETTINGSDIRECTORY\user\registry\data\org\openoffice\Office\Paths.xcu"
			Goto CheckForPassedParameters

	SetupDocumentsPathPortableApps:
		ReadEnvStr $PORTABLEAPPSTEMP "PortableApps.comTemp"
		Delete "$SETTINGSDIRECTORY\user\registry\data\org\openoffice\Office\Paths.xcu"
		
		;=== Setup our paths
		${StrReplace} $0  "\" "/" $PORTABLEAPPSTEMP
		${StrReplace} $1  " " "%20" $0
		${StrReplace} $0  "\" "/" $PORTABLEAPPSDOCUMENTS
		${StrReplace} $2  " " "%20" $0
		FileOpen $0 "$SETTINGSDIRECTORY\user\registry\data\org\openoffice\Office\Paths.xcu" w
		FileWrite $0 `<?xml version="1.0" encoding="UTF-8"?>`
		FileWriteByte $0 "10"
		FileWrite $0 `<oor:component-data xmlns:oor="http://OOo4Kids/2001/registry" xmlns:xs="http://www.w3.org/2001/XMLSchema" oor:name="Paths" oor:package="org.OOo4Kids.Office">`
		FileWriteByte $0 "10"
		FileWrite $0 ` <node oor:name="Paths">`
		FileWriteByte $0 "10"
		FileWrite $0 `  <node oor:name="Temp">`
		FileWriteByte $0 "10"	
		FileWrite $0 `   <prop oor:name="WritePath" oor:type="xs:string">`
		FileWriteByte $0 "10"	
		FileWrite $0 `    <value>file:///$1</value>`
		FileWriteByte $0 "10"	
		FileWrite $0 `   </prop>`
		FileWriteByte $0 "10"	
		FileWrite $0 `  </node>`
		FileWriteByte $0 "10"	
		FileWrite $0 `  <node oor:name="Work">`
		FileWriteByte $0 "10"	
		FileWrite $0 `   <prop oor:name="WritePath" oor:type="xs:string">`
		FileWriteByte $0 "10"	
		FileWrite $0 `    <value>file:///$2</value>`
		FileWriteByte $0 "10"	
		FileWrite $0 `   </prop>`
		FileWriteByte $0 "10"	
		FileWrite $0 `  </node>`
		FileWriteByte $0 "10"	
		FileWrite $0 ` </node>`
		FileWriteByte $0 "10"		
		FileWrite $0 `</oor:component-data>`
		FileWriteByte $0 "10"			
		FileClose $0

	CheckForPassedParameters:
		;=== Get any passed parameters
		${GetParameters} $0
		StrCmp "'$0'" "''" "" LaunchProgramParameters

		;=== No parameters
		StrCpy $EXECSTRING `"$PROGRAMDIRECTORY\program\$PROGRAMEXECUTABLE"`
		Goto AdditionalParameters

	LaunchProgramParameters:
		StrCpy $EXECSTRING `"$PROGRAMDIRECTORY\program\$PROGRAMEXECUTABLE" $0`

	AdditionalParameters:
		StrCpy $EXECSTRING `$EXECSTRING${DEFAULTPARAMETERS}`
	
		StrCmp $ADDITIONALPARAMETERS "" SetSettingsPath

		;=== Additional Parameters
		StrCpy $EXECSTRING `$EXECSTRING $ADDITIONALPARAMETERS`

	SetSettingsPath:
		;=== Set the settngs directory if we have a path
		StrCmp $RUNDATALOCALLY "true" LocalSettingsPath
		IfFileExists `$PROGRAMDIRECTORY\program\bootstrap.ini` ""  NoBootStrap
			StrCmp $SECONDARYLAUNCH "true" LaunchAndClose
			StrCmp $ISDEFAULTDIRECTORY "true" SettingsDefault SettingsNotDefault
			SettingsDefault:
				ReadINIStr $0 `$PROGRAMDIRECTORY\program\bootstrap.ini` "Bootstrap" "UserInstallation"
				StrCmp $0 "$$ORIGIN/../../../Data/settings" CheckJava
				WriteINIStr `$PROGRAMDIRECTORY\program\bootstrap.ini` "Bootstrap" "UserInstallation" "$$ORIGIN/../../../Data/settings"
				Goto CheckJava
				
			SettingsNotDefault:
				${StrReplace} $SETTINGSDIRECTORYWITHOUTSPACES  " " "%20" $SETTINGSDIRECTORY
				${StrReplace} $SETTINGSDIRECTORYBOOTSTRAP  "\" "/" $SETTINGSDIRECTORYWITHOUTSPACES
				;MessageBox MB_OK|MB_ICONINFORMATION `file:///$SETTINGSDIRECTORYBOOTSTRAP`
				WriteINIStr `$PROGRAMDIRECTORY\program\bootstrap.ini` "Bootstrap" "UserInstallation" "file:///$SETTINGSDIRECTORYBOOTSTRAP"
				Goto CheckJava

	NoBootStrap:
		StrCpy $MISSINGFILEORPATH `$PROGRAMDIRECTORY\program\bootstrap.ini`
		MessageBox MB_OK|MB_ICONEXCLAMATION `$(LauncherFileNotFound)`
		Abort
		
	LocalSettingsPath:
		ReadINIStr $0 `$PROGRAMDIRECTORY\program\bootstrap.ini` "Bootstrap" "UserInstallation"
		StrCmp $0 "$$SYSUSERHOME/${NAME}Temp/settings" CheckJava
		WriteINIStr `$PROGRAMDIRECTORY\program\bootstrap.ini` "Bootstrap" "UserInstallation" "$$SYSUSERHOME/${NAME}Temp/settings"
	

	CheckJava:
		Delete "$SETTINGSDIRECTORY\user\config\javasettings_Windows_x86.xml" ;=== Reset the Java settings
		StrCmp $RUNDATALOCALLY "true" LaunchNow
		IfFileExists "$EXEDIR\App\Java\javaportable.ini" "" CheckJavaCommonFiles
			StrCpy $JAVADIRECTORY "$EXEDIR\App\Java\"
			ReadINIStr $JAVAVENDOR "$EXEDIR\App\Java\javaportable.ini" "JavaPortable" "Vendor"
			ReadINIStr $JAVAVERSION "$EXEDIR\App\Java\javaportable.ini" "JavaPortable" "Version"
			Goto SetupJavaPath
		
	CheckJavaCommonFiles:
		${GetParent} $EXEDIR $PORTABLEAPPSDIRECTORY
		IfFileExists "$PORTABLEAPPSDIRECTORY\CommonFiles\Java\javaportable.ini" "" LaunchNow
			StrCpy $JAVADIRECTORY "$PORTABLEAPPSDIRECTORY\CommonFiles\Java\"
			ReadINIStr $JAVAVENDOR "$PORTABLEAPPSDIRECTORY\CommonFiles\Java\javaportable.ini" "JavaPortable" "Vendor"
			ReadINIStr $JAVAVERSION "$PORTABLEAPPSDIRECTORY\CommonFiles\Java\javaportable.ini" "JavaPortable" "Version"
		
	SetupJavaPath:
		${StrReplace} $JAVAPATHCONFIG "\" "/" "file:\\\$JAVADIRECTORY"
		
		StrCpy $0 `$JAVAPATHCONFIG` # temp variable to hold path to process
	
	ConvertPathToHex:
		StrCpy $1 $0 1 # pull the first letter
		${CharToASCII} $2 $1
		IntFmt $3 "%X" $2 # converted to hex in variable 3
		StrCpy $JAVAPATHCONFIGHEX `$JAVAPATHCONFIGHEX$300` # add it to our hex string
		StrCpy $0 $0 "" 1 # pop the first character off
		StrCmp $0 "" DoneConvertingPathToHex ConvertPathToHex # no more characters?

	DoneConvertingPathToHex:	
		;=== Create a new config
		CreateDirectory "$SETTINGSDIRECTORY\user\config"
		FileOpen $0 "$SETTINGSDIRECTORY\user\config\javasettings_Windows_x86.xml" w
		FileWrite $0 `<?xml version="1.0" encoding="UTF-8"?>`
		FileWriteByte $0 "10"
		FileWrite $0 `<!--This is a generated file. Do not alter this file!-->`
		FileWriteByte $0 "10"
		FileWrite $0 `<java xmlns="http://OOo4Kids/2004/java/framework/1.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">`
		FileWriteByte $0 "10"
		FileWrite $0 `<enabled xsi:nil="true"/>`
		FileWriteByte $0 "10"
		FileWrite $0 `<userClassPath xsi:nil="true"/>`
		FileWriteByte $0 "10"		
		FileWrite $0 `<vmParameters xsi:nil="true"/>`
		FileWriteByte $0 "10"
		FileWrite $0 `<jreLocations xsi:nil="false">`
		FileWriteByte $0 "10"
		FileWrite $0 `<location>$JAVAPATHCONFIG</location>`
		FileWriteByte $0 "10"
		FileWrite $0 `</jreLocations>`
		FileWriteByte $0 "10"
		FileWrite $0 `<javaInfo xsi:nil="false" vendorUpdate="2004-01-30" autoSelect="false">`
		FileWriteByte $0 "10"
		FileWrite $0 `<vendor>$JAVAVENDOR</vendor>`
		FileWriteByte $0 "10"
		FileWrite $0 `<location>$JAVAPATHCONFIG</location>`
		FileWriteByte $0 "10"
		FileWrite $0 `<version>$JAVAVERSION</version>`
		FileWriteByte $0 "10"
		FileWrite $0 `<features>0</features>`
		FileWriteByte $0 "10"
		FileWrite $0 `<requirements>0</requirements>`
		FileWriteByte $0 "10"
		FileWrite $0 `<vendorData>$JAVAPATHCONFIGHEX620069006E002F0063006C00690065006E0074002F006A0076006D002E0064006C006C00</vendorData>`
		FileWriteByte $0 "10"
		FileWrite $0 `</javaInfo>`
		FileWriteByte $0 "10"
		FileWrite $0 `</java>`
		FileWriteByte $0 "10"
		FileWriteByte $0 "10"
		FileClose $0
	
	LaunchNow:
		StrCmp $WAITFORPROGRAM "true" LaunchAndWait LaunchAndClose

	LaunchAndWait:
		StrCmp $SECONDARYLAUNCH "true" LaunchAndClose
		ExecWait $EXECSTRING
		StrCmp $RUNDATALOCALLY "true" "" TheEnd
		RMDir /r "$DOCUMENTSDIRECTORY\${NAME}Temp\"
		GoTo TheEnd

	LaunchAndClose:
		Exec $EXECSTRING

	TheEnd:
SectionEnd